<?php
/*
 *Name         : page.isymphony.php
 *Author       : Michael Yara
 *Created      : July 2, 2008
 *Last Updated : August 22, 2008
 *History      : 0.5 
 *Purpose      : Information page for iSymphony module
 *Copyright    : 2008 HEHE Enterprises, LLC
 */


//Turn on debugging if it is requested
$debugUrlAddition = "";
$debugMenuAddition = "";
if(($debug = isset($_REQUEST["debug"])) === true) {
$debugUrlAddition = "&debug=yes";
$debugMenuAddition = "	<tr><td colspan=\"2\"><h5>Module Debug<hr></h5></td></tr>
						<tr><td><a href=\"/admin/modules/isymphony/debug.txt\" target=\"_blank\">View Debug Log</a></td></tr>
						<tr><td><a href=\"/admin/modules/isymphony/error.txt\" target=\"_blank\">View Error Log</a></td></tr>
						<tr><td><a href=\"config.php?type=setup&display=isymphony&showdb=yes$debugUrlAddition\">View Database</a></td></tr>";	
}
	
//Check to see if the server is running
$psOutput = array();
$serverRunning = false;
$serverRunningDisplay = "";
exec("ps -auxww | grep java", $psOutput);

foreach($psOutput as $line) {
	if(strstr($line, "iSymphonyServer.jar") !== false) {
		$serverRunning = true;
		break;
	}
}

$serverRunningDisplay = $serverRunning ? "<span style=\"color: #00FF00\">Up</span>" : "<span style=\"color: #FF0000\">Down</span>";

//Check for a reload action
if($serverRunning && iSymphonyConnect() && isset($_REQUEST["isymphony_reload"])) {
	
	//Reload server and block for 5 secs so server can repopulate
	reloadISymphonyServer();
	sleep(5);
}

//Check for a license activation action
$licenseActivationError = "";
if($serverRunning && iSymphonyConnect() && isset($_REQUEST["isymphony_activate_license"]) && isset($_REQUEST["isymphony_license_key"]) && (trim($_REQUEST["isymphony_license_key"]) != "")) {
	
	if(activateISymphonyLicense("default", "default", trim($_REQUEST["isymphony_license_key"])) === false) {
		$licenseActivationError = $ISERROR;
	}
	
	//Block for 5 secs to let location reload
	sleep(5);
	
	//Close iSymphony connection
	iSymphonyDisconnect();
}

//Check if a request to show the database was made
$databaseDisplay = "";
if($debug && isset($_REQUEST["showdb"])) {
	
	//Build extensions table
	$databaseDisplay .= "	<table>
								<tr>
									<tr><td colspan = \"6\"><h5>Extensions</h5></td></tr>
								</tr>
								<tr>
									<td>User ID&nbsp&nbsp&nbsp</td>
									<td>Add Extension&nbsp&nbsp&nbsp</td>
									<td>Add Profile&nbsp&nbsp&nbsp</td>
									<td>Password&nbsp&nbsp&nbsp</td>
									<td>Display Name&nbsp&nbsp&nbsp</td>
									<td>Peer&nbsp&nbsp&nbsp</td>
								<tr>
								</tr>
									<td colspan = \"6\"><hr></td>
								</tr>";

	foreach(isymphony_user_list() as $user) {
		$databaseDisplay .= "	<tr>
									<td>{$user['user_id']}</td>
									<td>{$user['add_extension']}</td>
									<td>{$user['add_profile']}</td>
									<td>{$user['password']}</td>
									<td>{$user['display_name']}</td>
									<td>{$user['peer']}</td>
								</tr>";
	}

	$databaseDisplay .= "</table>";
	
	//Build queues table
	$databaseDisplay .= "	<table>
								<tr>
									<tr><td colspan = \"3\"><h5>Queues</h5></td></tr>
								</tr>
								<tr>
									<td>Queue ID&nbsp&nbsp&nbsp</td>
									<td>Add Queue&nbsp&nbsp&nbsp</td>
									<td>Display Name&nbsp&nbsp&nbsp</td>
								<tr>
								</tr>
									<td colspan = \"3\"><hr></td>
								</tr>";

	foreach(isymphony_queue_list() as $queue) {
		$databaseDisplay .= "	<tr>
									<td>{$queue['queue_id']}</td>
									<td>{$queue['add_queue']}</td>
									<td>{$queue['display_name']}</td>
								</tr>";
	}

	$databaseDisplay .= "</table>";
	
	//Build conference room table
	$databaseDisplay .= "	<table>
								<tr>
									<tr><td colspan = \"3\"><h5>Conference Rooms</h5></td></tr>
								</tr>
								<tr>
									<td>Conference Room ID&nbsp&nbsp&nbsp</td>
									<td>Add Conference Room&nbsp&nbsp&nbsp</td>
									<td>Display Name&nbsp&nbsp&nbsp</td>
								<tr>
								</tr>
									<td colspan = \"3\"><hr></td>
								</tr>";

	foreach(isymphony_conference_room_list() as $conferenceRoom) {
		$databaseDisplay .= "	<tr>
									<td>{$conferenceRoom['conference_room_id']}</td>
									<td>{$conferenceRoom['add_conference_room']}</td>
									<td>{$conferenceRoom['display_name']}</td>
								</tr>";
	}

	$databaseDisplay .= "</table>";
}

//Connect to iSymphony server to query information
if($serverRunning && iSymphonyConnect()) {
				
	//Get server version
	if(($versionDisplay = getiSymphonyServerVersion()) === false) {
		$versionDisplay = "";
	}

	//Get licensed to name
	if(($licensedToDisplay = getISymphonyLicenseName("default", "default")) === false) {
		$licensedToDisplay = "";
	}
	
	//Get license days
	if(($licenseTrialDaysDisplay = getISymphonyLicenseTrialDays("default", "default")) === false) {
		$licenseTrialDaysDisplay = "";
	}
	
	//Get license clients
	if(($licenseClientsDisplay = getISymphonyLicenseClients("default", "default")) === false) {
		$licenseClientsDisplay = "";
	}
	
	//Get license queues
	if(($licenseQueuesDisplay = getISymphonyLicenseQueues("default", "default")) === false) {
		$licenseQueuesDisplay = "";
	}

	//Build action buttons
	$reloadServerButton = "	<form name=\"isymphony_reload_form\" action=\"config.php?type=setup&display=isymphony$debugUrlAddition\" method=\"post\">
								<input type=\"Submit\" name=\"isymphony_reload\" value=\"Reload\">
							</form>";
	$activateLicenseButton = "	<form name=\"isymphony_activate_license_form\" action=\"config.php?type=setup&display=isymphony$debugUrlAddition\" method=\"post\">
									<input type=\"text\" name=\"isymphony_license_key\">
									<input type=\"Submit\" name=\"isymphony_activate_license\" value=\"Activate\">
								</form>";

	//Close iSymphony connection
	iSymphonyDisconnect();

} else {
	$versionDisplay = "";
	$licensedToDisplay = "";
	$licenseTrialDaysDisplay = "";
	$licenseClientsDisplay = "";
	$licenseQueuesDisplay = "";
	$reloadServerButton = "";
	$activateLicenseButton = "";
}

//Display license activation error if any
if($licenseActivationError != "") {
	$licenseActivationError = "	<span style=\"color: #FF0000\">
									An error occurred while activating your license:<br>
									$licenseActivationError
								</span>";
}

$display = "<div class=\"content\">
				$licenseActivationError
				<h2>iSymphony</h2>
				<table>
					<tr><td colspan=\"2\"><h5>Server<hr></h5></td></tr>
					<tr>
						<td><a href=\"#\" class=\"info\">Status:<span>Displays if the iSymphony server is running.</span></a></td>
						<td>$serverRunningDisplay</td>						
					</tr>
					<tr>
						<td><a href=\"#\" class=\"info\">Version:<span>Displays the version of the iSymphony server.</span></a></td>
						<td>$versionDisplay</td>						
					</tr>
					<tr>
						<td><a href=\"#\" class=\"info\">Reload Server:<span>Reloads the iSymphony server.</span></a>&nbsp&nbsp</td>
						<td>$reloadServerButton</td>						
					</tr>

					<tr><td colspan=\"2\"><h5>License<hr></h5></td></tr>
					<tr>
						<td><a href=\"#\" class=\"info\">Licensed To:<span>Displays the name of the person or company this server is licensed to.</span></a></td>
						<td>$licensedToDisplay</td>						
					</tr>
					<tr>
						<td><a href=\"#\" class=\"info\">Trial Days:<span>Displays the number of remaining license trial days.</span></a></td>
						<td>$licenseTrialDaysDisplay</td>						
					</tr>
					<tr>
						<td><a href=\"#\" class=\"info\">Clients:<span>Displays the number of licensed clients.</span></a></td>
						<td>$licenseClientsDisplay</td>						
					</tr>
					<tr>
						<td><a href=\"#\" class=\"info\">Queues:<span>Displays the number of licensed queues.</span></a></td>
						<td>$licenseQueuesDisplay</td>						
					</tr>
					<tr>
						<td><a href=\"#\" class=\"info\">Activate:<span>Activates a license with a given serial key.</span></a></td>
						<td>$activateLicenseButton</td>						
					</tr>
					$debugMenuAddition
				</table>
				$databaseDisplay
			<table>
				<tr>
					<td><h5>Description<hr></h5></td>
				</tr>
				<tr>
					<td>
					<p>This module will automatically sync the iSymphony Configuration with the current FreePBX configuration so that you will not have 
						to manually configure Extension, Profiles, Queues, and Conference Rooms in iSymphony. Any time you add, remove, edit an Extension, 
						Queue, or Conference Room in FreePBX the changes will automatically be applied to iSymphony. You can control what elements will be
						available in iSymphony by using the check boxes in the iSymphony section of the User/Extension, Queue, and Conference Room pages.
						By default the profile passwords will be set to \"secret\" but they can be modified on the User/Extension page.
					</p>
					<p> 
						Dont forget to register at <a href=\"http://www.i9technologies.com/isymphony\">http://www.i9technologies.com/isymphony</a> to get your free Conductor Edition 
						trial license to experience the full features of iSymphony. You will also get a Free Registered Edition license with 5 clients that is yours for life. If you have a license key you can enter it above.
					</p>
						<strong>Note: Queues and Conferences are only available in Conductor Edition.</strong>
					</td>
				</tr>
				<tr>
					<td><br><h5>Getting Started<hr></h5></td>
				</tr>
				<tr>
					<td>1. Make sure that the FreePBX \"Asterisk API\" module is installed and activated.</td>
				</tr>
				<tr>
					<td>2. Go <a href=\"http://www.i9technologies.com/isymphony\">here</a> and download the iSymphony Server, Client, and User Manual.</td>
				</tr>
				<tr>
					<td>3. If you are using iSymphony 2.1 or higher skip steps 4, 5, and 6.</td>
				</tr>
				<tr>
					<td>4. Open <strong>/etc/freepbx/amportal.conf</strong></td>
				</tr>
				<tr>
					<td>5. Look for the line <strong>#POST_RELOAD=</strong></td>
				</tr>
				<tr>
					<td>6. Modify it to read <strong>POST_RELOAD=bash /var/www/html/admin/modules/isymphony/post_reload.sh</strong></td>
				</tr>
				<tr>
					<td>7. Follow the Server Installation instruction in the User Manual. Skip steps 3 and 5 as this module will add the appropriate contexts<br> 
						automatically. Also Skip the Administration section in the manual, since this module will automatically configure iSymphony for you, and<br> 
						move on to the Client Installation portion when instructed to do so.
					</td>
				</tr>
				<tr>
					<td>8. Reload your FreePBX configuration so it can sync the iSymphony configuration with FreePBX.</td>
				</tr>
				<tr>
					<td>9. Move on to the iSymphony Client Installation portion of the manual to start using iSymphony.</td>
				</tr>
				<tr>
					<td>10. If you would like further modification of the iSymphony Server than this module provides see the the Server Configuration section under<br> 
						Administration in the manual on how to connect to the iSymphony Administrator.</td>
				</tr>
			</table>
			<br>
			<br>
			For more information please visit <a href=\"http://www.i9technologies.com/isymphony\">http://www.i9technologies.com/isymphony</a>
			</div>";

echo $display;
echo "<br>";
?>