<?php 
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }
/** Language Module for FreePBX 2.4
 * Copyright 2006 Philippe Lindheimer - Astrogen LLC
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

$type = isset($_REQUEST['type']) ? $_REQUEST['type'] : 'setup';
$action = isset($_REQUEST['action']) ? $_REQUEST['action'] :  '';
if (isset($_REQUEST['delete'])) $action = 'delete';

$name = isset($_REQUEST['name']) ? $_REQUEST['name'] :  false;
$content = isset($_REQUEST['content']) ? $_REQUEST['content'] :  false;

if (isset($_REQUEST["content"])) {
        $a = explode("\n",$_REQUEST["content"]);

        foreach (array_keys($a) as $key) {
                //trim it
                $a[$key] = trim($a[$key]);

                // remove invalid chars
                $a[$key] = preg_replace("/[^0-9,]/", "", $a[$key]);

                // remove blanks
                if ($a[$key] == "") unset($a[$key]);
        }
	
	$content = implode("\n", $a);
}

switch ($action) {
        case 'add':
                queuerules_add($name, $content);
                needreload();
                redirect_standard();
        break;
        case 'edit':
                queuerules_edit($name, $content);
                needreload();
                redirect_standard('extdisplay');
        break;
        case 'delete':
                queuerules_delete($name);
                needreload();
                redirect_standard();
        break;
}

?> 
<div class="rnav"><ul>
<?php 

echo '<li><a href="config.php?display=queuerules&amp;type='.$type.'">'._('Add Queue Rule').'</a></li>';

foreach (queuerules_list() as $row) {
	echo '<li><a href="config.php?display=queuerules&amp;type='.$type.'&amp;extdisplay='.$row['name'].'" class="">'.$row['name'].'</a></li>';
}

?>
</ul></div>

<?php

if ($extdisplay) {
	// load
	$row = queuerules_get($extdisplay);
	
	$name = $row['name'];
	$content = $row['content'];

	echo "<h2>"._("Edit: ")."$name"."</h2>";
} else {
	echo "<h2>"._("Add Queue Rule")."</h2>";
}

$helptext = _("Queue Rules allows you to change the Queue Max Penalty and Queue Min Penalty values in mid-call by defining rules in the queue for when to do so. This can allow for a call to be opened to more members or potentially a different set of members after some period of time that it stays in the queue.<br>
You define the rule as a set of lines each consisting in three integer values separated by commas. The first value is the time in seconds after which the rule is applied; the second is the new value for the Queue Max Penalty variable; the third, which is optional, is the new value for the Queue Min Penalty variable.<br>
For example, a rule consisting in<br><b>30,10,5<br>60,+3<br>75,,7</b><br> means after 30 seconds in the queue, set the Queue Max Penalty to 10 and set the Queue Min Penalty to 5; after 60 seconds in the queue, increase the Queue Max Penalty by 3; after 75 seconds in the queue, set the Queue Min Penalty to 7.
");
echo $helptext;
?>

<form name="editQueueRules" action="<?php  $_SERVER['PHP_SELF'] ?>" method="post" onsubmit="return checkQueueRules(editQueueRules);">
	<input type="hidden" name="extdisplay" value="<?php echo $extdisplay; ?>">
	<input type="hidden" name="action" value="<?php echo ($extdisplay ? 'edit' : 'add'); ?>">
	<table>
	<tr><td colspan="2"><h5><?php  echo ($extdisplay ? _("Edit Queue Rule") : _("Add Queue Rule")) ?><hr></h5></td></tr>
	<tr>
		<td><a href="#" class="info"><?php echo _("Name")?>:<span><?php echo _("The name of this Queue Rule.")?></span></a></td>
		<td><input size="30" type="text" name="name" value="<?php  echo $name; ?>" tabindex="<?php echo ++$tabindex;?>"></td>
	</tr>
	<tr>
		<td><a href="#" class="info"><?php echo _("Rule")?>:<span><?php echo _("The content of this Queue Rule.")?></span></a></td>

                <td valign="top">
                        <textarea id="content" cols="22" rows="<?php  $rows = count(explode("\n", $content))+1; echo (($rows < 5) ? 5 : (($rows > 20) ? 20 : $rows) ); ?>" name="content" tabindex="<?php echo ++$tabindex;?>"><?php echo $content ?></textarea>
                </td>

	</tr>
			
	<tr>
		<td colspan="2"><br><input name="Submit" type="submit" value="<?php echo _("Submit Changes")?>" tabindex="<?php echo ++$tabindex;?>">
			<?php if ($extdisplay) { echo '&nbsp;<input name="delete" type="submit" value="'._("Delete").'">'; } ?>
		</td>		
	</tr>
</table>
</form>

<script queuerules="javascript">
<!--

function checkQueueRules(theForm) {
	var msgInvalidDescription = "<?php echo _('Invalid description specified'); ?>";

	// set up the Destination stuff
	setDestinations(theForm, '_post_dest');

	// form validation
	defaultEmptyOK = false;	
	if (isEmpty(theForm.name.value))
		return warnInvalid(theForm.name, msgInvalidDescription);

	//if (!validateDestinations(theForm, 1, true))
	//	return false;

	return true;
}
//-->
</script>
