#!/usr/bin/perl -w 
use strict;

# La regexp con cui scremo le extension da listare. 
# Di default il numero viene listato.
# Se fa match con maskdeny, non viene listato, a meno che non faccia match con maskallow.
my $maskallow = qr/^100$/o;
my $maskdeny = qr/\d\d\d\d/o; # caccio le key con almeno 3 cifre

use Getopt::Std;

sub help() {
	print "Uso: $0\n";
	print " L'ordinamento predefinito e' in base al numero della estensione\n";
}

my %opts = (o => "i");
getopts('o:', \%opts) or help;

use CGI;
use CGI::Carp qw( fatalsToBrowser );
$ENV{PATH} = '/sbin:/bin:/usr/sbin:/usr/bin';

my $q   = new CGI;
$opts{o} = defined $q->param( "sort" ) ? $q->param( "sort" ) : $opts{o};

my %cidnames;
my $numsd;
my $numcid;

open(PPP,'/usr/sbin/asterisk -rx "database show" | ') or die "Non riesco ad eseguire asterisk database show";
while(<PPP>) {
	if(s-^/AMPUSER/(\d+)/cidname-$1-) {
		chomp;
# /AMPUSER/30/cidname     : 30 LUIGI IOTTI
		my ($key,$val) = split /\s+:\s+/;
		$val =~ s/\s*$//;
		$val =~ s/^\s*$key\s*//; # Elimino l'eventuale numero all'inizio della descrizione
		next if $key =~ /$maskdeny/ && $key !~ /$maskallow/;
		#print "$key $val\n";
		$cidnames{$key} = $val;
		$numcid++;
	}
}
close PPP;


# Uso un hash di appoggio ulteriore per associare la riga da stampare alla chiave che rappresenta la grandezza sulla quale ordinare l'output
my %risultato;
for(keys %cidnames) {
	$risultato{$_} = sprintf "%-4s %s\n", $_, $cidnames{$_};
}

print $q->header( "text/html" ),
$q->start_html({-bgcolor=>'#FFCCCC'}, "Selezione dominio" ),
$q->span({-style=>'font-weight:bold ; font-size:30pt ; color: black'},  "Interni locali" );
print '<pre>';

my $num = 0;
for(sort {$a <=> $b} keys %risultato) {
	my $color = $num % 2 ? "#FFCCCC" : "#FFCCFF";
	print $q->span({-style=>'width: 100% ; font-weight:bold ; font-size:16pt ; background: ' . $color}, $risultato{$_});
	#print $q->p({-color='red'}, $risultato{$_});
	print $q->br;
	$num++;
}

print $q->end_html;
