#!/usr/bin/perl -w 
use strict;

use Getopt::Std;

sub help() {
	print "Uso: $0 [-os|-od]\n";
	print " -os : ordina in base al numero abbreviato\n";
	print " -od : ordina in base alla descrizione\n";
	print " L'ordinamento predefinito e' in base al numero di telefono\n";
}

my %opts = (o => "i");
getopts('o:', \%opts) or help;

use CGI;
use CGI::Carp qw( fatalsToBrowser );
$ENV{PATH} = '/sbin:/bin:/usr/sbin:/usr/bin';

my $q   = new CGI;
$opts{o} = defined $q->param( "sort" ) ? $q->param( "sort" ) : $opts{o};

my %speeddials;
my %cidnames;
my $numsd = 0;
my $numcid = 0;

open(PPP,'/usr/sbin/asterisk -rx "database show" | ') or die "Non riesco ad eseguire asterisk database show";
while(<PPP>) {
	if(s-^/sysspeeddials/--) {
		chomp;
# /sysspeeddials/389                                : 03296718474              
		my ($key,$val) = split /\s+:\s+/;
		$val =~ s/\s*$//;
		#print "$key $val\n";
		$speeddials{$val} = $key;
		$numsd++;
	} elsif (s-^/cidname/--) {
		chomp;
# /cidname/03357258320                              : BORTOLANI                
		my ($key,$val) = split /\s+:\s+/;
		$val =~ s/\s*$//;
		#print "$key $val\n";
		$cidnames{$key} = $val;
		$numcid++;
	}
}
close PPP;


# Uso un hash di appoggio ulteriore per associare la riga da stampare alla chiave che rappresenta la grandezza sulla quale ordinare l'output
my %risultato;
for(keys %cidnames) {
	if($opts{o} eq "s") {
		$risultato{$speeddials{$_}} = sprintf "%-4s %15s %s\n", $speeddials{$_}, $_, $cidnames{$_};
	} elsif($opts{o} eq "d") {
		$risultato{$cidnames{$_}} = sprintf "%-4s %15s %s\n", $speeddials{$_}, $_, $cidnames{$_};
	} else {
		$risultato{$_} = sprintf "%-4s %15s %s\n", $speeddials{$_}, $_, $cidnames{$_};
	}
}

print $q->header( "text/html" ),
$q->start_html({-bgcolor=>'#FFCCCC'}, "Selezione dominio" ),
$q->span({-style=>'font-weight:bold ; font-size:30pt ; color: black'},  "Numeri brevi" );
print '<pre>';

my $num = 0;
for(sort keys %risultato) {
	my $color = $num % 2 ? "#FFCCCC" : "#FFCCFF";
	print $q->span({-style=>'width: 100% ; font-weight:bold ; font-size:16pt ; background: ' . $color}, $risultato{$_});
	#print $q->p({-color='red'}, $risultato{$_});
	print $q->br;
	$num++;
}

print $q->p("ATTENZIONE: trovati $numsd speeddials e $numcid cidnames\n") if $numsd != $numcid;

print $q->end_html;
